#include <bits/stdc++.h>
using namespace std;

int solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    sort(a.begin(), a.end());
    sort(b.begin(), b.end());

    auto check = [&](int ch) {
        for (int i = 0; i < n; ++i) {
            int nr = 0, l = 0, y = n;
            for (int j = n - 1; j >= 0; --j) {
                if (b[j] - a[i] >= ch)
                    ++nr, y = j;
                else break;
            }

            int x = 0;
            for (int j = i; j < n; ++j) {
                while (x < y && a[j] - b[x] >= ch) {
                    ++nr;
                    ++x;
                }
                ++l;
                if (l > nr)
                    return false;
            }
        }

        return true;
    };

    int st = 0, dr = 1e9;
    while (st <= dr) {
        int mij = (st + dr) / 2;
        if (check(mij))
            st = mij + 1;
        else dr = mij - 1;
    }

    return dr;
}

int main() {
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--)
        cout << solve() << "\n";
    return 0;
}
