#include <bits/stdc++.h>
using namespace std;
int main() {
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n, m;
    cin >> n >> m;

    vector<pair<int, vector<int>>> v(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        v[i].first = i + 1;
        v[i].second.resize(k);
        for (auto &it : v[i].second) {
            cin >> it;
        }
    }

    sort(v.begin(), v.end(), [](auto &&x, auto &&y) { return x.second.size() < y.second.size();});
    vector<int> f(m + 1, 0);
    vector<int> len(n + 1, 0);
    vector<int> wh(n + 1, 0);
    int ids = 0;
    for (auto &it : v) {
        vector<int> &mul = it.second;

        if (ids == 0) {
            int id = ++ids;
            for (auto val : mul)
                f[val] = id;
            len[id] = mul.size();
            wh[id] = it.first;
        } else {
            map<int, int> ap;
            for (auto val : mul) {
                if (f[val]) {
                    ++ap[f[val]];
                }
            }

            for (auto val : ap) {
                if (len[val.first] != val.second) {
                    cout << "YES\n";
                    cout << it.first << " " << wh[val.first] << "\n";
                    return 0;
                }
            }

            int id = ++ids;
            for (auto val : mul)
                f[val] = id;
            len[id] = mul.size();
            wh[id] = it.first;
        }
    }

    cout << "NO\n";
    return 0;
}
